#include <iostream>
#include <stdlib.h>

#include <solution.h>
#include <init.h>
#include <eval.h>
#include <population.h>
#include <evolutionaryAlgorithm.h>

using namespace std;

/**
 *  Main function
 */
int main(int argc, char **argv) {
  /***
   * the parameters of the evolutionary algorithm
   */

  // initialization of the random numbers sequence
  if (argc == 2) 
    // initialization of the random numbers sequence
    srandom(atoi(argv[1]));

  // length of the bit strings
  int n = 1000;

  // Evaluation function (oneMax)
  OneMax eval(n);

  // population size of the parents
  int mu = 10;

  // population size of childrens
  int lambda = 50;

  // initialization method of solutions
  RandomInit initSol(n);

  // tournament size for selection
  int tournamentSize = 2;

  // rates of crossOver and mutation
  double crossOverRate = 0.8;

  // rates of mutation
  double mutationRate = 1.0;
		
  // maximum number of generation
  int maxGeneration = 1000;

  /***
   * the evolutionary algorithm
   */

  // Evolutionary algorithm with all the parameters
  EvolutionaryAlgorithm ea(eval, mu, lambda, initSol, tournamentSize, crossOverRate, mutationRate, maxGeneration);

  /***
   * execution of the algorithm
   */

  // the population
  Population population ;

  // let's run !
  ea.run(population);
  
}
