public class Population {
    // individuals of the population
    public Solution [] individuals;

    // size of the population
    private int size;

    /*
     * Constructor to create a population of size mu
     */
    public Population(int mu) {
	this.size = 0;
	resize(mu);
    }

    /*
     * Constructor to create a population of size mu
     */
    public Population() {
	this.size = 0;
    }

    /*
     * if the population size is different
     * remove the population
     * and create a new population of size mu
     */
    public void resize(int mu) {
	if (this.size != mu) {
	    this.size = mu;
	    individuals = new Solution[this.size];
	    for(int i = 0; i < this.size; i++)
		individuals[i] = new Solution();
	}
    }

    public int getSize() {
	return this.size;
    }

    /*
     * best solution of the population according to the maximumization problem
     */
    public Solution bestSolution() {
	if (size == 0) 
	    return null;
	else {
	    Solution best = this.individuals[0];
	    for(int i = 1; i < size; i++) {
		if (individuals[i].fitness() > best.fitness())
		    best = individuals[i];
	    } 
	    
	    return best;
	}
    }

    /*
     * Calcule la fitness moyenne de la population
     */
    public double averageFitness() {
	if (size == 0) 
	    return 0;
	else {
	    double sum = 0.0;
	    for(int i = 0; i < size; i++) {
		sum += individuals[i].fitness();
	    } 
	    
	    return sum / (double) size;
	}
    }

    public String toString() {
	String res = size + "\n";
	
	for(int i = 0; i < size; i++) {
	    res += this.individuals[i] + "\n" ;
	}

	return res;
    }
}
